<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [bullmq](./bullmq.md)

## bullmq package

## Classes

|  Class | Description |
|  --- | --- |
|  [Backoffs](./bullmq.backoffs.md) |  |
|  [ChildPool](./bullmq.childpool.md) |  |
|  [ChildProcessor](./bullmq.childprocessor.md) | ChildProcessor<!-- -->This class acts as the interface between a child process and it parent process so that jobs can be processed in different processes than the parent. |
|  [FlowProducer](./bullmq.flowproducer.md) | This class allows to add jobs with dependencies between them in such a way that it is possible to build complex flows. Note: A flow is a tree-like structure of jobs that depend on each other. Whenever the children of a given parent are completed, the parent will be processed, being able to access the children's result data. All Jobs can be in different queues, either children or parents, |
|  [Job](./bullmq.job.md) |  |
|  [Queue](./bullmq.queue.md) | Queue<!-- -->This class provides methods to add jobs to a queue and some othe high-level administration such as pausing or deleting queues. |
|  [Queue3](./bullmq.queue3.md) |  |
|  [QueueBase](./bullmq.queuebase.md) |  |
|  [QueueEvents](./bullmq.queueevents.md) | The QueueEvents class is used for listening to the global events emitted by a given queue.<!-- -->This class requires a dedicated redis connection. |
|  [QueueGetters](./bullmq.queuegetters.md) |  |
|  [QueueKeys](./bullmq.queuekeys.md) |  |
|  [QueueScheduler](./bullmq.queuescheduler.md) | This class is just used for some automatic bookkeeping of the queue, such as updating the delay set as well as moving stalled jobs back to the waiting list.<!-- -->Jobs are checked for stallness once every "visibility window" seconds. Jobs are then marked as candidates for being stalled, in the next check, the candidates are marked as stalled and moved to wait. Workers need to clean the candidate list with the jobs that they are working on, failing to update the list results in the job ending being stalled.<!-- -->This class requires a dedicated redis connection, and at least one is needed to be running at a given time, otherwise delays, stalled jobs, retries, repeatable jobs, etc, will not work correctly or at all. |
|  [RedisConnection](./bullmq.redisconnection.md) |  |
|  [Repeat](./bullmq.repeat.md) |  |
|  [ScriptLoader](./bullmq.scriptloader.md) | Lua script loader with include support |
|  [ScriptLoaderError](./bullmq.scriptloadererror.md) |  |
|  [Scripts](./bullmq.scripts.md) |  |
|  [TimerManager](./bullmq.timermanager.md) | Keeps track on timers created with setTimeout to help clearTimeout for all timers when no more delayed actions needed |
|  [UnrecoverableError](./bullmq.unrecoverableerror.md) | UnrecoverableError<!-- -->Error to move a job to failed even if the attemptsMade are lower than the expected limit. |
|  [Worker](./bullmq.worker.md) | This class represents a worker that is able to process jobs from the queue. As soon as the class is instantiated it will start processing jobs. |

## Enumerations

|  Enumeration | Description |
|  --- | --- |
|  [ChildCommand](./bullmq.childcommand.md) |  |
|  [ClientType](./bullmq.clienttype.md) |  |
|  [ErrorCode](./bullmq.errorcode.md) |  |
|  [MetricsTime](./bullmq.metricstime.md) |  |
|  [ParentCommand](./bullmq.parentcommand.md) |  |

## Functions

|  Function | Description |
|  --- | --- |
|  [array2obj(arr)](./bullmq.array2obj.md) |  |
|  [delay(ms)](./bullmq.delay.md) |  |
|  [getParentKey(opts)](./bullmq.getparentkey.md) |  |
|  [isEmpty(obj)](./bullmq.isempty.md) |  |
|  [isNotConnectionError(error)](./bullmq.isnotconnectionerror.md) |  |
|  [isRedisCluster(obj)](./bullmq.isrediscluster.md) |  |
|  [isRedisInstance(obj)](./bullmq.isredisinstance.md) |  |
|  [jobIdForGroup(jobOpts, data, queueOpts)](./bullmq.jobidforgroup.md) |  |
|  [killAsync(child, signal, timeoutMs)](./bullmq.killasync.md) | Sends a kill signal to a child resolving when the child has exited, resorting to SIGKILL if the given timeout is reached |
|  [lengthInUtf8Bytes(str)](./bullmq.lengthinutf8bytes.md) | Checks the size of string for ascii/non-ascii characters |
|  [raw2jobData(raw)](./bullmq.raw2jobdata.md) |  |
|  [removeAllQueueData(client, queueName, prefix)](./bullmq.removeallqueuedata.md) |  |
|  [tryCatch(fn, ctx, args)](./bullmq.trycatch.md) |  |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [AddChildrenOpts](./bullmq.addchildrenopts.md) |  |
|  [AddNodeOpts](./bullmq.addnodeopts.md) |  |
|  [AdvancedOptions](./bullmq.advancedoptions.md) |  |
|  [BackoffOptions](./bullmq.backoffoptions.md) | Settings for backing off failed jobs. |
|  [ChildMessage](./bullmq.childmessage.md) |  |
|  [ChildProcessExt](./bullmq.childprocessext.md) |  |
|  [Command](./bullmq.command.md) |  |
|  [DependenciesOpts](./bullmq.dependenciesopts.md) |  |
|  [FlowJob](./bullmq.flowjob.md) |  |
|  [FlowOpts](./bullmq.flowopts.md) |  |
|  [GetNextJobOptions](./bullmq.getnextjoboptions.md) |  |
|  [IConnection](./bullmq.iconnection.md) |  |
|  [JobInformation3](./bullmq.jobinformation3.md) |  |
|  [JobJson](./bullmq.jobjson.md) |  |
|  [JobJsonRaw](./bullmq.jobjsonraw.md) |  |
|  [JobNode](./bullmq.jobnode.md) |  |
|  [JobPromise3](./bullmq.jobpromise3.md) |  |
|  [JobsOptions](./bullmq.jobsoptions.md) |  |
|  [KeepJobs](./bullmq.keepjobs.md) | KeepJobs<!-- -->Specify which jobs to keep after finishing. If both age and count are specified, then the jobs kept will be the ones that satisfies both properties. |
|  [Metrics](./bullmq.metrics.md) |  |
|  [MetricsOptions](./bullmq.metricsoptions.md) |  |
|  [MoveToChildrenOpts](./bullmq.movetochildrenopts.md) |  |
|  [NodeOpts](./bullmq.nodeopts.md) |  |
|  [ObliterateOpts](./bullmq.obliterateopts.md) |  |
|  [Parent](./bullmq.parent.md) | Describes the parent for a Job. |
|  [ParentKeys](./bullmq.parentkeys.md) |  |
|  [ParentMessage](./bullmq.parentmessage.md) |  |
|  [QueueBaseOptions](./bullmq.queuebaseoptions.md) | Base Queue options |
|  [QueueEventsListener](./bullmq.queueeventslistener.md) |  |
|  [QueueEventsOptions](./bullmq.queueeventsoptions.md) | Options for QueueEvents |
|  [QueueListener](./bullmq.queuelistener.md) |  |
|  [QueueOptions](./bullmq.queueoptions.md) | Options for the Queue class. |
|  [QueueSchedulerListener](./bullmq.queueschedulerlistener.md) |  |
|  [QueueSchedulerOptions](./bullmq.queuescheduleroptions.md) | Options for customizing the behaviour of the scheduler. |
|  [RateLimiterOptions](./bullmq.ratelimiteroptions.md) |  |
|  [RepeatOptions](./bullmq.repeatoptions.md) | Settings for repeatable jobs |
|  [SandboxedJob](./bullmq.sandboxedjob.md) |  |
|  [ScriptMetadata](./bullmq.scriptmetadata.md) | Script metadata |
|  [Strategies](./bullmq.strategies.md) |  |
|  [WorkerListener](./bullmq.workerlistener.md) |  |
|  [WorkerOptions](./bullmq.workeroptions.md) |  |

## Variables

|  Variable | Description |
|  --- | --- |
|  [asyncSend](./bullmq.asyncsend.md) |  |
|  [childSend](./bullmq.childsend.md) |  |
|  [clientCommandMessageReg](./bullmq.clientcommandmessagereg.md) |  |
|  [DELAY\_TIME\_1](./bullmq.delay_time_1.md) |  |
|  [DELAY\_TIME\_5](./bullmq.delay_time_5.md) |  |
|  [errorObject](./bullmq.errorobject.md) |  |
|  [parentSend](./bullmq.parentsend.md) |  |
|  [QUEUE\_EVENT\_SUFFIX](./bullmq.queue_event_suffix.md) |  |
|  [QUEUE\_SCHEDULER\_SUFFIX](./bullmq.queue_scheduler_suffix.md) |  |
|  [scriptLoader](./bullmq.scriptloader.md) |  |
|  [WORKER\_SUFFIX](./bullmq.worker_suffix.md) |  |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [ActiveEventCallback3](./bullmq.activeeventcallback3.md) |  |
|  [BackoffFunction](./bullmq.backofffunction.md) |  |
|  [BulkJobOptions](./bullmq.bulkjoboptions.md) |  |
|  [CleanedEventCallback3](./bullmq.cleanedeventcallback3.md) |  |
|  [ClusterOptions](./bullmq.clusteroptions.md) |  |
|  [CompletedEventCallback3](./bullmq.completedeventcallback3.md) |  |
|  [ConnectionOptions](./bullmq.connectionoptions.md) |  |
|  [EntryId](./bullmq.entryid.md) |  |
|  [EntryRaw](./bullmq.entryraw.md) |  |
|  [ErrorEventCallback3](./bullmq.erroreventcallback3.md) |  |
|  [EventCallback3](./bullmq.eventcallback3.md) |  |
|  [FailedEventCallback3](./bullmq.failedeventcallback3.md) |  |
|  [FinishedPropValAttribute](./bullmq.finishedpropvalattribute.md) |  |
|  [FinishedStatus](./bullmq.finishedstatus.md) |  |
|  [FlowQueuesOpts](./bullmq.flowqueuesopts.md) |  |
|  [JobData](./bullmq.jobdata.md) |  |
|  [JobJsonSandbox](./bullmq.jobjsonsandbox.md) |  |
|  [JobState](./bullmq.jobstate.md) |  |
|  [JobStatusClean3](./bullmq.jobstatusclean3.md) |  |
|  [JobType](./bullmq.jobtype.md) |  |
|  [KeysMap](./bullmq.keysmap.md) |  |
|  [MinimalQueue](./bullmq.minimalqueue.md) |  |
|  [ParentOpts](./bullmq.parentopts.md) |  |
|  [Processor](./bullmq.processor.md) | An async function that receives <code>Job</code>s and handles them. |
|  [ProgressEventCallback3](./bullmq.progresseventcallback3.md) |  |
|  [RedisClient](./bullmq.redisclient.md) |  |
|  [RedisOptions](./bullmq.redisoptions.md) |  |
|  [RemovedEventCallback3](./bullmq.removedeventcallback3.md) |  |
|  [SandboxedJobProcessor](./bullmq.sandboxedjobprocessor.md) |  |
|  [StalledEventCallback3](./bullmq.stalledeventcallback3.md) |  |
|  [StreamName](./bullmq.streamname.md) |  |
|  [StreamReadRaw](./bullmq.streamreadraw.md) |  |
|  [WaitingEventCallback3](./bullmq.waitingeventcallback3.md) |  |

